# WebBlocks

## Overview

Out of the box, WebBlocks is a platform based on modern web technologies for 
building full-featured, responsive sites suited for all viewports including 
desktops, tablets and mobile devices. It leverages existing best-in-breed web 
tools, defines semantics based on modern web standards and includes a large 
suite of UI elements and Javascript interactivity libraries. However, WebBlocks 
is a lot more than just a set of semantics, elements and libraries. At it's 
core, it is a highly modular toolkit that can be customized to meet business 
needs, fitted to different development paradigms and integrated into existing 
web solutions.

[![Build Status](https://travis-ci.org/ucla/WebBlocks.png)](https://travis-ci.org/ucla/WebBlocks)

Documentation for WebBlocks is available within the `doc` folder or online at:
http://ucla.github.io/WebBlocks/doc

## License

WebBlocks is open-source software licensed under the BSD 3-clause license. The 
full text of the license may be found in the `LICENSE` file.

## Credits

### Collaboration

WebBlocks is a collaborative project involving the University of California, 
the Mobile Web Framework community, and others. The toolkit is a product of 
its collaborators, both those who have participated in discussion and those 
who have contributed code.

The integration manager for WebBlocks is Eric Bollens <ebollens@ucla.edu>.

### Third-Party Packages and Software

WebBlocks may leverage a number of external packages:

* Alpha Image Scaling - http://unstoppablerobotninja.com/entry/fluid-images
* Efx - BSD License - http://github.com/ebollens/efx
* FitVids.js - WTFPL License - https://github.com/davatron5000/FitVids.js
* HTTP Client Hints - Public Domain - https://github.com/jonathantneal/http-client-hints
* jQuery - MIT License - http://jquery.com
* matchMedia.js - MIT License - https://github.com/paulirish/matchMedia.js
* Modernizr - MIT or BSD License - http://modernizr.com
* Picturefill - MIT or GPLv2 License - https://github.com/scottjehl/picturefill
* Respond.js - MIT or GPLv2 License - https://github.com/scottjehl/Respond
* Selectivizr - MIT License - http://selectivizr.com
* srcset-polyfill - MIT License - https://github.com/borismus/srcset-polyfill
* Twitter Bootstrap - Apache License - http://twitter.github.com/bootstrap

WebBlocks also uses the following software directly within its build process:

* Ruby - http://www.ruby-lang.org
* Rubygems - http://rubygems.org
* Bundler - http://gembundler.com
* Rake - http://rake.rubyforge.org
* Node.js - http://nodejs.org
* NPM - https://npmjs.org
* SASS - http://sass-lang.com
* Compass - http://compass-style.org
* rb-fsevent - https://rubygems.org/gems/rb-fsevent
* systemu - https://rubygems.org/gems/systemu
* uglifycss - https://npmjs.org/package/uglifycss
* uglify-js - https://npmjs.org/package/uglify-js

A sincere thanks to all of these authors for making their fine work available.
